package com.xxl.job.executor.ads.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.xxl.job.executor.ads.entity.AiKuaishouStrategyMapCreative;
import com.xxl.job.executor.ads.service.IAiKuaishouStrategyMapCreativeService;
import com.xxl.job.executor.entity.vo.Result;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Arrays;

 /**
 * 智能投放快手定向策略详细信息
 * @author jeecg-boot
 * @date   2020-12-10
 * @version V1.0
 */
@Slf4j
@RestController
@RequestMapping("/ctop/aiKuaishouStrategyMapCreative")
public class AiKuaishouStrategyMapCreativeController {
	@Autowired
	private IAiKuaishouStrategyMapCreativeService aiKuaishouStrategyMapCreativeService;

	/**
	  * 分页列表查询
	 * @param aiKuaishouStrategyMapCreative
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	@GetMapping(value = "/list")
	public Result<IPage<AiKuaishouStrategyMapCreative>> queryPageList(AiKuaishouStrategyMapCreative aiKuaishouStrategyMapCreative,
																	  @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
																	  @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
																	  HttpServletRequest req) {
		Result<IPage<AiKuaishouStrategyMapCreative>> result = new Result<>();
		QueryWrapper<AiKuaishouStrategyMapCreative> queryWrapper = new QueryWrapper<>();
		Page<AiKuaishouStrategyMapCreative> page = new Page<>(pageNo, pageSize);
		IPage<AiKuaishouStrategyMapCreative> pageList = aiKuaishouStrategyMapCreativeService.page(page, queryWrapper);
		result.setSuccess(true);
		result.setResult(pageList);
		return result;
	}

	/**
	  *   添加
	 * @param aiKuaishouStrategyMapCreative
	 * @return
	 */
	@PostMapping(value = "/add")
	public Result<AiKuaishouStrategyMapCreative> add(@RequestBody AiKuaishouStrategyMapCreative aiKuaishouStrategyMapCreative) {
		Result<AiKuaishouStrategyMapCreative> result = new Result<>();
		try {
			aiKuaishouStrategyMapCreativeService.save(aiKuaishouStrategyMapCreative);
			result.success("添加成功！");
		} catch (Exception e) {
			log.error(e.getMessage(),e);
			result.error500("操作失败");
		}
		return result;
	}

	/**
	  *  编辑
	 * @param aiKuaishouStrategyMapCreative
	 * @return
	 */
	@PutMapping(value = "/edit")
	public Result<AiKuaishouStrategyMapCreative> edit(@RequestBody AiKuaishouStrategyMapCreative aiKuaishouStrategyMapCreative) {
		Result<AiKuaishouStrategyMapCreative> result = new Result<AiKuaishouStrategyMapCreative>();
		AiKuaishouStrategyMapCreative aiKuaishouStrategyMapCreativeEntity = aiKuaishouStrategyMapCreativeService.getById(aiKuaishouStrategyMapCreative.getId());
		if(aiKuaishouStrategyMapCreativeEntity==null) {
			result.error500("未找到对应实体");
		}else {
			boolean ok = aiKuaishouStrategyMapCreativeService.updateById(aiKuaishouStrategyMapCreative);
			if(ok) {
				result.success("修改成功!");
			}
		}

		return result;
	}

	/**
	  *   通过id删除
	 * @param id
	 * @return
	 */
	@DeleteMapping(value = "/delete")
	public Result<?> delete(@RequestParam(name="id",required=true) String id) {
		try {
			aiKuaishouStrategyMapCreativeService.removeById(id);
		} catch (Exception e) {
			log.error("删除失败",e.getMessage());
			return Result.error("删除失败!");
		}
		return Result.ok("删除成功!");
	}

	/**
	  *  批量删除
	 * @param ids
	 * @return
	 */
	@DeleteMapping(value = "/deleteBatch")
	public Result<AiKuaishouStrategyMapCreative> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		Result<AiKuaishouStrategyMapCreative> result = new Result<>();
		if(ids==null || "".equals(ids.trim())) {
			result.error500("参数不识别！");
		}else {
			this.aiKuaishouStrategyMapCreativeService.removeByIds(Arrays.asList(ids.split(",")));
			result.success("删除成功!");
		}
		return result;
	}

	/**
	  * 通过id查询
	 * @param id
	 * @return
	 */
	@GetMapping(value = "/queryById")
	public Result<AiKuaishouStrategyMapCreative> queryById(@RequestParam(name="id",required=true) String id) {
		Result<AiKuaishouStrategyMapCreative> result = new Result<>();
		AiKuaishouStrategyMapCreative aiKuaishouStrategyMapCreative = aiKuaishouStrategyMapCreativeService.getById(id);
		if(aiKuaishouStrategyMapCreative==null) {
			result.error500("未找到对应实体");
		}else {
			result.setResult(aiKuaishouStrategyMapCreative);
			result.setSuccess(true);
		}
		return result;
	}
}
