package com.xxl.job.executor.ads.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.xxl.job.executor.ads.entity.AiKuaishouStrategyTargetDetails;
import com.xxl.job.executor.ads.service.IAiKuaishouStrategyTargetDetailsService;
import com.xxl.job.executor.entity.vo.Result;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Arrays;

 /**
 * 智能投放快手定向策略详细信息
 * @author jeecg-boot
 * @date   2020-12-10
 * @version V1.0
 */
@Slf4j
@RestController
@RequestMapping("/ctop/aiKuaishouStrategyTargetDetails")
public class AiKuaishouStrategyTargetDetailsController {
	@Autowired
	private IAiKuaishouStrategyTargetDetailsService aiKuaishouStrategyTargetDetailsService;

	/**
	  * 分页列表查询
	 * @param aiKuaishouStrategyTargetDetails
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	@GetMapping(value = "/list")
	public Result<IPage<AiKuaishouStrategyTargetDetails>> queryPageList(AiKuaishouStrategyTargetDetails aiKuaishouStrategyTargetDetails,
																		@RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
																		@RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
																		HttpServletRequest req) {
		Result<IPage<AiKuaishouStrategyTargetDetails>> result = new Result<>();
		QueryWrapper<AiKuaishouStrategyTargetDetails> queryWrapper = new QueryWrapper<>();
		Page<AiKuaishouStrategyTargetDetails> page = new Page<AiKuaishouStrategyTargetDetails>(pageNo, pageSize);
		IPage<AiKuaishouStrategyTargetDetails> pageList = aiKuaishouStrategyTargetDetailsService.page(page, queryWrapper);
		result.setSuccess(true);
		result.setResult(pageList);
		return result;
	}

	/**
	  *   添加
	 * @param aiKuaishouStrategyTargetDetails
	 * @return
	 */
	@PostMapping(value = "/add")
	public Result<AiKuaishouStrategyTargetDetails> add(@RequestBody AiKuaishouStrategyTargetDetails aiKuaishouStrategyTargetDetails) {
		Result<AiKuaishouStrategyTargetDetails> result = new Result<>();
		try {
			aiKuaishouStrategyTargetDetailsService.save(aiKuaishouStrategyTargetDetails);
			result.success("添加成功！");
		} catch (Exception e) {
			log.error(e.getMessage(),e);
			result.error500("操作失败");
		}
		return result;
	}

	/**
	  *  编辑
	 * @param aiKuaishouStrategyTargetDetails
	 * @return
	 */
	@PutMapping(value = "/edit")
	public Result<AiKuaishouStrategyTargetDetails> edit(@RequestBody AiKuaishouStrategyTargetDetails aiKuaishouStrategyTargetDetails) {
		Result<AiKuaishouStrategyTargetDetails> result = new Result<AiKuaishouStrategyTargetDetails>();
		AiKuaishouStrategyTargetDetails aiKuaishouStrategyTargetDetailsEntity = aiKuaishouStrategyTargetDetailsService.getById(aiKuaishouStrategyTargetDetails.getId());
		if(aiKuaishouStrategyTargetDetailsEntity==null) {
			result.error500("未找到对应实体");
		}else {
			boolean ok = aiKuaishouStrategyTargetDetailsService.updateById(aiKuaishouStrategyTargetDetails);
			if(ok) {
				result.success("修改成功!");
			}
		}

		return result;
	}

	/**
	  *   通过id删除
	 * @param id
	 * @return
	 */
	@DeleteMapping(value = "/delete")
	public Result<?> delete(@RequestParam(name="id",required=true) String id) {
		try {
			aiKuaishouStrategyTargetDetailsService.removeById(id);
		} catch (Exception e) {
			log.error("删除失败",e.getMessage());
			return Result.error("删除失败!");
		}
		return Result.ok("删除成功!");
	}

	/**
	  *  批量删除
	 * @param ids
	 * @return
	 */
	@DeleteMapping(value = "/deleteBatch")
	public Result<AiKuaishouStrategyTargetDetails> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		Result<AiKuaishouStrategyTargetDetails> result = new Result<>();
		if(ids==null || "".equals(ids.trim())) {
			result.error500("参数不识别！");
		}else {
			this.aiKuaishouStrategyTargetDetailsService.removeByIds(Arrays.asList(ids.split(",")));
			result.success("删除成功!");
		}
		return result;
	}

	/**
	  * 通过id查询
	 * @param id
	 * @return
	 */
	@GetMapping(value = "/queryById")
	public Result<AiKuaishouStrategyTargetDetails> queryById(@RequestParam(name="id",required=true) String id) {
		Result<AiKuaishouStrategyTargetDetails> result = new Result<>();
		AiKuaishouStrategyTargetDetails aiKuaishouStrategyTargetDetails = aiKuaishouStrategyTargetDetailsService.getById(id);
		if(aiKuaishouStrategyTargetDetails==null) {
			result.error500("未找到对应实体");
		}else {
			result.setResult(aiKuaishouStrategyTargetDetails);
			result.setSuccess(true);
		}
		return result;
	}
}
